package com.alterdekim.game.component.game;

import com.alterdekim.game.xml.NumericBooleanSerializer;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlProperty;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.time.LocalDateTime;

@AllArgsConstructor
@Getter
public class AvatarInventoryItem {
    @JacksonXmlProperty(localName = "ID", isAttribute = true)
    private Long id;

    @JacksonXmlProperty(localName = "TextResourceID", isAttribute = true)
    private Integer textResourceID;

    @JacksonXmlProperty(localName = "BodyPartId", isAttribute = true)
    private Integer bodyPartId;

    @JacksonXmlProperty(localName = "MediaResourceID", isAttribute = true)
    private Integer mediaResourceID;

    @JacksonXmlProperty(localName = "IsUsed", isAttribute = true)
    @JsonSerialize(using= NumericBooleanSerializer.class)
    private Boolean isUsed;

    @JacksonXmlProperty(localName = "IsColorable", isAttribute = true)
    @JsonSerialize(using= NumericBooleanSerializer.class)
    private Boolean isColorable;

    @JacksonXmlProperty(localName = "Color", isAttribute = true)
    private Integer color;

    @JacksonXmlProperty(localName = "IsLimited", isAttribute = true)
    @JsonSerialize(using= NumericBooleanSerializer.class)
    private Boolean isLimited;

    @JacksonXmlProperty(localName = "Date", isAttribute = true)
    private LocalDateTime date;

    @JacksonXmlProperty(localName = "Pollution", isAttribute = true)
    private Integer pollution;

    @JacksonXmlProperty(localName = "IsBodyPart", isAttribute = true)
    @JsonSerialize(using= NumericBooleanSerializer.class)
    private Boolean isBodyPart;

    @JacksonXmlProperty(localName = "GoodID", isAttribute = true)
    public Long getGoodId() {
        return this.id;
    }
}
